/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/*
 * main_window.h
 * Copyright (C) Mike Crash 2008 <mike@mikecrash.com>
 *
 * main.cc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * main.cc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIN_WINDOW_H_INCLUDED
#define MAIN_WINDOW_H_INCLUDED 1

#include <gtkmm.h>
#include <sys/time.h>

struct MainWindow : public Gtk::Window
{
private:
  //time
  struct timeval time_start;
  struct timeval time_split;
  struct timeval time_stop;
  struct timeval time_lap;
  time_t last_sec;
  int mode;  //0=zero, 1=run, 2=stop
  int split; //0=no split, 1=splited

  //buttons
  Gtk::Button *button_start;
  Gtk::Button *button_lap;
  Gtk::Button *button_clear;
  Gtk::Button *button_split;

  //labels
  Gtk::Label *label_chrono;
  Gtk::Label *label_time;
  Gtk::Label *label_split;
  Gtk::TextView *textview_laps;
  Glib::RefPtr<Gtk::TextBuffer> textbuffer_laps;

  void CreateWidgets(void);
  void CreateTime(char *s, struct timeval*start, struct timeval*stop);

public:
  MainWindow();
  ~MainWindow();
  
  void on_button_start_clicked();
  void on_button_lap_clicked();
  void on_button_clear_clicked();
  void on_button_split_clicked();
  bool on_timeout(int timer_number);
};

#endif //MAIN_WINDOW_H_INCLUDED
